﻿
var cancelIcon = "http://icons.iconarchive.com/icons/custom-icon-design/flatastic-1/64/cancel-icon.png";
var successURL = "https://www.facebook.com/connect/login_success.html";
// var successURL = "https://app.sotel.vn/admin/fb";

var user = {}
var ready = false;
function getTimestamp() {
    return Math.floor(Date.now() / 1000);
}
async function delay(seconds) {
    return new Promise(resolve => setTimeout(resolve, seconds));
}

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if(ready){
        // console.log("Ready is true, calling messageListener");
        messageListenner(request, sender, sendResponse);
        return true;
    }
    // console.log("Ready is false, waiting...");
    var itv = setInterval(() => {
        if (ready) {
            // console.log("Ready became true, calling messageListener");
            messageListenner(request, sender, sendResponse);
            clearInterval(itv);
        }
    }, 100);
        
    return true;
});
function messageListenner(request, sender, sendResponse) {
    // console.log("In messageListener, request:", request);
    if (request.status == "getPhone") {
        if (!user.authcode) {
            sendResponse({
                status: 400,
                phone: "Vui lòng đăng nhập extension!",
                picture: cancelIcon,
                email: '',
                location: '',
            });
        } else {
            if (request.type == 'uid') {
                findPhoneAndSendResponse(request, sendResponse);
            } else {
                getUidbyUsername(request.uid).then(uid => {
                    request.uid = uid;
                    findPhoneAndSendResponse(request, sendResponse);
                })

            }
        }

    } else if (request.status == 'url') {
        if (request.url.includes(successURL)) {
            chrome.tabs.remove(sender.tab.id);
            var accessToken = request.url.split("#access_token=")[1];
            if (accessToken) {
                chrome.storage.local.set({ accessToken: accessToken });
            }
            loginWebsite(accessToken);
        }
    } else if (request.status == 'getInfo') {
        fetch("https://app.sotel.vn/api/Users/getInfo", {
            "headers": {
                "accept": "application/json, text/javascript, */*; q=0.01",
                "authorization": user.authcode,
            },
        }).then(x => x.json()).then(x => {
            sendResponse(x);
        });
    } else if (request.status == 'getLastScan') {
        fetch("https://app.sotel.vn/api/Users/getLastScan", {
            "headers": {
                "accept": "application/json, text/javascript, */*; q=0.01",
                "authorization": user.authcode,
            },
        }).then(x => x.json()).then(x => {
            sendResponse(x);
        });
    } else if (request.status == 'logout') {
        user = {};
    }
}

function findPhoneAndSendResponse(request, sendResponse) {
    // console.log("findPhoneAndSendResponse", request);
    var url = "https://app.sotel.vn/api/Users2/getTel?";
    url += "uid=" + encodeURIComponent(request.uid);
    url += "&src=" + request.source;
    url += "&src_link=" + request.source_link;
    url += "&uname=" + request.name;
    fetch(url, {
        "headers": {
            "accept": "application/json, text/javascript, */*; q=0.01",
            "authorization": user.authcode,
        },
    }).then(x => x.json()).then(res => {
        if (res.status == 200 || res.status == 201) {
            sendResponse({
                status: res.status,
                phone: res.message.data.phone,
                picture: res.message.data.picture,
                email: res.message.data.email,
                location: res.message.data.location,

            })
        } else {
            sendResponse({
                status: res.status,
                phone: res.message,
                picture: cancelIcon,
                email: "",
                location: "",
            });
        }

    });
}


function getUidbyUsername(username) {
    return new Promise(resolve => {
        username = username.split('?')[0];
        username = username.replace(/[^a-z0-9.]/gi, "");
        fetch("https://www.facebook.com/" + username, {
            "headers": {
                "accept": "application/json, text/plain, */*",
                "accept-language": "vi-VN,vi;q=0.9,fr-FR;q=0.8,fr;q=0.7,en-US;q=0.6,en;q=0.5",
                "sec-ch-ua": "\"Google Chrome\";v=\"117\", \"Not;A=Brand\";v=\"8\", \"Chromium\";v=\"117\"",
                "sec-ch-ua-mobile": "?0",
                "sec-ch-ua-platform": "\"Windows\"",
                "sec-fetch-dest": "empty",
                "sec-fetch-mode": "cors",
                "sec-fetch-site": "none"
            },
            "referrerPolicy": "strict-origin-when-cross-origin",
            "method": "GET",
            "mode": "cors",
            "credentials": "include"
        }).then(x => x.text()).then(data => {
            var uid = /"userID":"(\d+)"/gm.exec(data);
            if (uid) uid = uid[1];
            else {
                var uid = /&amp;id=([0-9]+)&amp;set=/gm.exec(data);
                if (uid) uid = uid[1];
                else uid = false;
            }
            resolve(uid);
        });

    });
}
function loginWebsite(accessToken) {
    // data: {
    //     accessToken: accessToken,
    //     utm_source: utm_source,
    //     utm_medium: utm_medium,
    //     utm_name: utm_name,
    //     utm_term: utm_term,
    //     seller: seller,
    //   },
    fetch("https://app.sotel.vn/api/Users/loginfb", {
        "headers": {
            "accept": "application/json, text/javascript, */*; q=0.01",
            "accept-language": "vi-VN,vi;q=0.9,fr-FR;q=0.8,fr;q=0.7,en-US;q=0.6,en;q=0.5",
            "content-type": "application/x-www-form-urlencoded; charset=UTF-8",
        },
        "referrerPolicy": "strict-origin-when-cross-origin",
        "body": `accessToken=${accessToken}&utm_source=&utm_medium=&utm_name=&utm_term=&seller=`,
        "method": "POST",
        "mode": "cors",
        "credentials": "omit"
    }).then(x => x.json()).then(x => {
        console.log("loginfb");
        if (x.status == 200) {
            user = x.message.user;
            chrome.storage.local.set({
                user: user
            }, () => {
                console.log(user);
            });

        } else {
            console.error({
                message: "Login failed",
                data: x
            });
        }
    }).catch(error => {
        console.error("API call error:", error);
    });
}
function startApp() {
    setInterval(() => {
        // console.log("Time: " + getTimestamp());
    }, 10000);
    chrome.storage.local.get("user", item => {
        user = item.user ?? {};
        ready = true;
    });
}

startApp();